(function($) {
	
	$.gamesRegistry('register', 'drag', new (function() {
		
		this.options = {
				view_width:Infinity,
				view_height:Infinity,
				view_background_img:'',
				draggable:[]
			};
		
		this.clear=function()
		{
			$(".drag-item").draggable( "destroy" );
			$(".drop-zone").droppable( "destroy" );
			$(".drag-item").remove();
			$(".drop-zone").remove();
		},
		
		this.restart=function()
		{
			var self=this;
			
			var i=1;
		
			$.each(self.options.drop_zone, function(index,item)
			{
				$('#drop-zone-'+i).css('background-image', 'url("' + preload.getResult(item.image).src + '")');
				i++;
			});
			
			$.each($('.ui-draggable-disabled'),function(index,item){
				var number=parseInt($(item).attr('drag-item-id'),10);
				number--;
				var drag_item=self.options.draggable[number];
							
				area = new absoluteArea(drag_item);
				area.applyAt(item, {
						view_width : self.options.view_width,
						view_height: self.options.view_height
					});			
			});
			
			$('.ui-draggable-disabled').draggable("enable");
			$('.drag-item').show();
		}
		
		this.init = function(data, endCallback) {
			
			var self=this;
			
			$.extend(this.options, data);

			// Set background
			var background = preload.getResult(self.options.view_background_img).src;
			
			
			$('#playground').css('background-image', 'url("' + background + '")');
			
			function checkTask() {
				if($('.ui-draggable-disabled').length === Object.keys(self.options.drop_zone).length) {
					//pokazuje panel z gratulacjami
					$('.drag-item').hide();
					onCheckTask();
				}
			}
			
			setTimeout(function(){
				$('#start-page').fadeOut('slow', function(){
	    			$('.task-content').removeClass('hide');
		        	if (self.options.show_long_text!==undefined && self.options.show_long_text===true){
		        		$('#help').trigger('click');
		        	}
	    		});
 			

				var i=1;
				$.each(self.options.drop_zone, function(index,item) {
	
					var dropZoneItem = $('<div class="drop-zone" drag-zone-id="'+i+'" id="drop-zone-'+i+'"></div>');
	
					area = new absoluteArea(this);
					area.applyAt(dropZoneItem, {
							view_width : self.options.view_width,
							view_height: self.options.view_height
						});
	
					dropZoneItem.css('background-image', 'url("' + preload.getResult(item.image).src + '")');
					
					
					var item_id="#drag-item-"+item.accept_item;
				
					dropZoneItem.droppable({
						accept: item_id,
						drop: function(event, ui) {
							
							var number=parseInt($(this).attr('drag-zone-id'),10);
							number--;
							var drop_zone=self.options.drop_zone[number];
			
							dropZoneItem.css('background-image', 'url("' + preload.getResult(drop_zone.image_ondrop).src + '")');
							ui.draggable.hide();
							ui.draggable.draggable("disable");
							
							if (self.options.sound_ok!==undefined && self.options.sound_ok!='' && SOUND_ON) {
								if (snd_instance) snd_instance.stop();
								snd_instance=null;
								snd_instance=createjs.Sound.play(self.options.sound_ok, createjs.Sound.INTERUPT_LATE);
							}

							checkTask();
						}
					});				
					
					$('#playground').append(dropZoneItem);
					
					i++;
				});
				
				
				setTimeout(function(){
					
					var i=1;
					
					var start_x=self.options.draggable_start_x;
					var start_y=self.options.draggable_start_y;
					var offs_x=self.options.draggable_offs_x;
					
					var max_height=0;
					$.each(self.options.draggable, function(index,item) {
						var image=preload.getResult(this.image);
						if (max_height<image.height) max_height=image.height;
					});
					
					$.each(self.options.draggable, function(index,item) {
						
	
						var dragItem = $('<div style="z-index:100; display:none;" class="drag-item" drag-item-id="'+i+'" id="drag-item-'+item.id+'"></div>');
						i++;
						
						console.log(this.image);
						var image=preload.getResult(this.image);
						
						if (item.width===undefined) item.width=image.width;
						if (item.height===undefined) item.height=image.height;
						
						item.x=start_x;
						item.y=start_y+((max_height-item.height)/2);
						
						area = new absoluteArea(item);
						area.applyAt(dragItem, {
							view_width : self.options.view_width,
							view_height: self.options.view_height
						});
	
						dragItem.css('background-image', 'url("' + image.src + '")');
						
						$('#playground').append(dragItem);				
	
						dragItem.draggable({
							revert : 'invalid'
						});
						
						start_x+=item.width+offs_x;
						
						
					});
					
					$('.drag-item').show('slow');
					
				}, 2000);
			}, 500);
		};
	})());
	
})(jQuery);